SystemOrganization addCategory: #BichOS!

Object subclass: #Hormiga
	instanceVariableNames: 'alimentoTransportado estado lugaresDondeEstuvo distanciaRecorrida ubicacionActual'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'BichOS'!

!Hormiga commentStamp: '<historical>' prior: 0!
A Hormiga is xxxxxxxxx.

Instance Variables
	alimentoTransportado:		<Object>
	estado:		<Object>
	lugaresDondeEstuvo:		<Object>

alimentoTransportado
	- xxxxx

estado
	- xxxxx

lugaresDondeEstuvo
	- xxxxx
!

!Hormiga methodsFor: 'accessing' stamp: 'as 9/9/2015 22:37'!
alimentoTransportado
	^ alimentoTransportado! !

!Hormiga methodsFor: 'accessing' stamp: 'as 9/9/2015 22:44'!
alimentoTransportado: anObject
	alimentoTransportado := anObject! !

!Hormiga methodsFor: 'as yet unclassified' stamp: 'as 9/14/2015 22:48'!
distanciaPromedioRecorrida
	^(self distanciaRecorrida / (self lugaresDondeEstuvo size)).! !

!Hormiga methodsFor: 'as yet unclassified' stamp: 'as 9/14/2015 21:28'!
distanciaRecorrida
	^ distanciaRecorrida! !

!Hormiga methodsFor: 'accessing' stamp: 'as 9/14/2015 21:28'!
distanciaRecorrida: anObject
	distanciaRecorrida := anObject! !

!Hormiga methodsFor: 'as yet unclassified' stamp: 'as 9/9/2015 23:47'!
entregarAlimento
	alimentoTransportado := 0! !

!Hormiga methodsFor: 'as yet unclassified' stamp: 'as 9/14/2015 22:51'!
entregarAlimentoA: unHormiguero
	self alimentoTransportado: 0.
	self moveteA: unHormiguero.
	! !

!Hormiga methodsFor: 'as yet unclassified' stamp: 'as 9/9/2015 22:41'!
estaAlLimite
	^ ((self alimentoTransportado) >=9) & ((self alimentoTransportado) <=10)! !

!Hormiga methodsFor: 'accessing' stamp: 'as 9/9/2015 22:44'!
estado
	^ estado! !

!Hormiga methodsFor: 'accessing' stamp: 'as 9/9/2015 22:44'!
estado: anObject
	estado := anObject! !

!Hormiga methodsFor: 'as yet unclassified' stamp: 'as 9/14/2015 21:19'!
initialize
	estado := 1.
	alimentoTransportado := 5.
	metrosRecorridos := 0.! !

!Hormiga methodsFor: 'as yet unclassified' stamp: 'as 9/14/2015 21:22'!
lugaresDondeEstuvo
	^ lugaresDondeEstuvo! !

!Hormiga methodsFor: 'accessing' stamp: 'as 9/14/2015 21:22'!
lugaresDondeEstuvo: anObject
	lugaresDondeEstuvo := anObject! !

!Hormiga methodsFor: 'as yet unclassified' stamp: 'as 9/14/2015 21:30'!
moveteA: unaUbicacion
	self distanciaRecorrida: (self distanciaRecorrida + ubicacionActual distanciaA: unaUbicacion).
	self lugaresDondeEstuvo add: unaUbicacion.
	
	! !

!Hormiga methodsFor: 'accessing' stamp: 'as 9/14/2015 21:22'!
ubicacionActual
	^ ubicacionActual! !

!Hormiga methodsFor: 'accessing' stamp: 'as 9/14/2015 21:22'!
ubicacionActual: anObject
	ubicacionActual := anObject! !

Object subclass: #Hormiguero
	instanceVariableNames: 'hormigasQueTiene deposito ubicacion'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'BichOS'!

!Hormiguero commentStamp: '<historical>' prior: 0!
A Hormiguero is xxxxxxxxx.

Instance Variables
	deposito:		<Object>
	hormigasQueTiene:		<Object>

deposito
	- xxxxx

hormigasQueTiene
	- xxxxx
!

!Hormiguero methodsFor: 'as yet unclassified' stamp: 'as 9/9/2015 23:53'!
cantidadDeAlimentoQueLlevan
	^( self hormigasQueTiene sum:[: unaHormiga | unaHormiga alimentoTransportado.]).! !

!Hormiguero methodsFor: 'accessing' stamp: 'as 9/9/2015 23:53'!
cantidadDeAlimentoTotal
	^(self deposito + self cantidadDeAlimentoQueLlevan).! !

!Hormiguero methodsFor: 'as yet unclassified' stamp: 'as 9/9/2015 23:31'!
cantidadDeHormigas
	^( self hormigasQueTiene size).! !

!Hormiguero methodsFor: 'as yet unclassified' stamp: 'as 9/9/2015 23:44'!
cantidadDeHormigasAlLimite
	^( (self hormigasQueTiene select:[: unaHormiga | unaHormiga estaAlLimite.]) size).! !

!Hormiguero methodsFor: 'accessing' stamp: 'as 9/9/2015 23:54'!
deposito
	^ deposito! !

!Hormiguero methodsFor: 'accessing' stamp: 'as 9/9/2015 23:54'!
deposito: anObject
	deposito := anObject! !

!Hormiguero methodsFor: 'accessing' stamp: 'as 9/9/2015 23:30'!
hormigasQueTiene
	^ hormigasQueTiene! !

!Hormiguero methodsFor: 'accessing' stamp: 'as 9/9/2015 23:30'!
hormigasQueTiene: anObject
	hormigasQueTiene := anObject! !

!Hormiguero methodsFor: 'accessing' stamp: 'as 9/14/2015 23:14'!
recaudarAlimento
	deposito := self deposito + self cantidadDeAlimentoQueLlevan.
	self hormigasQueTiene do:[: unaHormiga | unaHormiga entregarAlimentoA: (self ubicacion) ].
	! !

!Hormiguero methodsFor: 'accessing' stamp: 'as 9/14/2015 23:13'!
ubicacion
	^ ubicacion! !

!Hormiguero methodsFor: 'accessing' stamp: 'as 9/14/2015 23:13'!
ubicacion: anObject
	ubicacion := anObject! !

Object subclass: #Ubicacion
	instanceVariableNames: 'unidadesX unidadesY'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'BichOS'!

!Ubicacion commentStamp: '<historical>' prior: 0!
An Ubicacion is xxxxxxxxx.

Instance Variables
	unidadesX:		<Object>
	unidadesY:		<Object>

unidadesX
	- xxxxx

unidadesY
	- xxxxx
!

!Ubicacion methodsFor: 'accessing' stamp: 'as 9/14/2015 22:57'!
distanciaA: otraUbicacion
	^(((self unidadesX - otraUbicacion unidadesX) raisedTo: 2) + ((self unidadesY - otraUbicacion unidadesY) raisedTo: 2)) sqrt.! !

!Ubicacion methodsFor: 'accessing' stamp: 'as 9/14/2015 21:32'!
unidadesX
	^ unidadesX! !

!Ubicacion methodsFor: 'accessing' stamp: 'as 9/14/2015 21:32'!
unidadesX: anObject
	unidadesX := anObject! !

!Ubicacion methodsFor: 'accessing' stamp: 'as 9/14/2015 21:32'!
unidadesY
	^ unidadesY! !

!Ubicacion methodsFor: 'accessing' stamp: 'as 9/14/2015 21:32'!
unidadesY: anObject
	unidadesY := anObject! !
